#include <string>
#include "xors3d.h"
#include "FIXorsBridge/FIXorsBridge.h"

int WINAPI WinMain(HINSTANCE hInstance,
					HINSTANCE hPrevInstance,
					LPSTR lpCmdLine,
					int nCmdShow)
{
	xAppTitle("FastImageBridge Example");
	xGraphics3D(800,600,32,false,false);

	xSetFont( xLoadFont("Arial",10));

	/*  FastImage */
	cFIXorsBridge* FIX = cFIXorsBridge::Initiate();

	if ( !FIX ) {
		return 0;
	}

	int font = FIX->LoadImageFont("font.txt");
	FIX->SetImageFont(font);

	int cam = xCreateCamera();
	int cub = xCreateCube();
	int light = xCreateLight();
	xPositionEntity(cam,10,10,10);
	xPointEntity(cam,cub);
	xRotateEntity(light,25,10,20);
	float x = 0;

	while (xWinMessage("WM_CLOSE")==0 && xKeyHit(1)==false) {
		xRenderWorld();

		FIX->StartDraw();
			FIX->SetBlend(FI_ALPHABLEND);

			FIX->SetRotation( 0 );
			FIX->DrawTextA("It is TEXT!!!", 10, 10);

			FIX->SetAlpha(0.7f);

			FIX->SetColor(27,177,243);
			FIX->SetRotation( x+=.1f );

			FIX->DrawRect(250,150,120,170);
			FIX->DrawRect(380,150,170,120);
			FIX->DrawRect(430,280,120,170);
			FIX->DrawRect(250,330,170,120);

		FIX->EndDraw();
		
		xFlip();
	}

	return(0);
}